#include <SoftwareSerial.h>
SoftwareSerial dataCommunication(2, 3);             // be aware to cross Tx and Rx between Arduino and Shield; SoftwareSerial baudrate must be < 38400

unsigned long fixTime = 0;                          // name changed : lastUpdate is a Arduino keyword
char Command = "";                                  // name changed : val is a Arduino keyword and character shall be bounded by ""
int ValueToSend = 0;                                // name changed : value is a Arduino keyword 

char dataReceived = "";                             // initialized character to empty ""
int coinPins[] = {10, 11, 12};
int currentCount = 0;
int pulseValue = 6;
int previousCoinStates[] = {LOW, LOW, LOW};
unsigned long previousTime = 0;                    // same as fixTime

void setup() {
  for (int i = 0; i < 3; i++) {
    pinMode(coinPins[i], INPUT_PULLUP);
  }
  Serial.begin(9600);
  dataCommunication.begin(9600);                  // supposing your BT shield is programmed @9600
  pinMode(9, OUTPUT);
}

void handleData() {
  if (dataCommunication.available() > 0) {
    Command = dataCommunication.read();
    Serial.print("Received from app = ");                   // debug on Serial Monitor
    Serial.println(Command);
    if (Command == '1'){                                    // the Command is a char then it shall be bounded by ''
      dataCommunication.println(ValueToSend);               // the app waits a Linefeed to detect end of frame then a ptintln() must be used 
      //sent this data under btn_1 to text_info 
    }else if (Command == '2'){
      dataCommunication.println(ValueToSend);
      //sent this data under btn_2 to text_info 
    }else if (Command == '3'){
      dataCommunication.println(ValueToSend);
      //sent this data under btn_3 to text_info 
    }
  }
}

void loop() {

  if (millis() - previousTime >= 60000) {
    currentCount = 0;                                     // each 1 minute resets to 0 currentCount
    previousTime = millis();
  }

  for (int i = 0; i < 3; i++) {
    int coinState = digitalRead(coinPins[i]);
    delay(50);                                            // be aware that delay() function blocks any othet activity (i.e. Tx and Rx for the delayed time)
    if (coinState == LOW && coinState != previousCoinStates[i]) {
      currentCount++;
      ValueToSend = currentCount * pulseValue;
      Serial.println("ValueToSend = ");                   // debug on Serial Monitor
      Serial.println(ValueToSend);
      ValueToSend += ValueToSend;
    }
    previousCoinStates[i] = coinState;
  }

  digitalWrite(9, currentCount == 0 ? HIGH : LOW);

  if (millis() - fixTime > 500) {                             // each 500 ms verifies the status of communication
    fixTime = millis();
    handleData();
  }
}
